###############################################################################
### UPSTREAMS
###############################################################################

{% set already_done = {} %}
{% for service in nginx_policies['services'] %}
  {% for mapping in service['mappings'] %}
    {% set upNameHash = mapping["has as source"] | join(mapping["has as destination"]) | hash('md5') %}

    {% if mapping["has as destination"] is not none and mapping["has as destination"]|length > 0 %}
      ### {{mapping["has as source"]}}
      upstream {{upNameHash}} {{'{'}}
        {% if mapping["has server persistence"] is none or mapping["has server persistence"] == "true" %}
          keepalive 100;
          keepalive_timeout  10000;
        {% endif %}

        # Memory shared zone for dns pool cache
        zone {{upNameHash}} 1024k;
        #least_conn;

        {% set destName = mapping['has as destination'] | regex_replace('https?://([^:/]+).*', '\\1') %}

        {% if mapping['has as destination'] | regex_search('https?://[^:]+:[\d]+') %}
          {% set destPort = mapping['has as destination'] | regex_replace('https?://[^:]+:([\d]+).*', '\\1') %}
          server {{destName}}:{{destPort}} resolve;
        {% elif mapping['has as destination'].startswith('https://') %}
          server {{destName}}:443 resolve;
        {% else %}
          server {{destName}} resolve;
        {% endif %}
      {{'}'}}
    {% endif %}
  {% endfor %}
{% endfor %}
